package Game.Entity
{
	import Game.GameScene;

	public class AI extends GameEntity
	{
		public var team:int;
		public var timer:Number;
		public var targets:Array;
		public var assets:Array;
		public var delay:Number;
		
		public function AI()
		{
			super();
			targets = [];
			assets = [];
		}
		
		public function initAI(game:GameScene, team:int, delay:Number=2.0):void {
			super.init(game);
			this.team = team;
			this.delay = delay;
			timer = delay + Math.random()*delay;
			targets.legnth = 0;
			assets.length = 0;
		}
		
		public override function update(dt:Number):void {
			timer -= dt;
			if(timer <= 0) {
				
				//get local center
				var localX:Number = 0;
				var localY:Number = 0;
				var nodes:Array = game.nodes.active;
				var l:int = nodes.length;
				var num:int = 0;
				for(var i:int = 0; i < l; i++) {
					var node:Node = nodes[i];
					if(node.team == team) {
						localX += node.x;
						localY += node.y;
						num++;
					}
				}
				localX /= num;
				localY /= num;
				
				targets.length = 0;
				for(i = 0; i < l; i++) {
					node = nodes[i];
					if(node.team != team) {
						var dx:Number = node.x - localX;
						var dy:Number = node.y - localY;
						var dist:Number = Math.sqrt(dx*dx +dy*dy);
						if(node.team != 0) node.aiVal = dist + Math.random()*100;
						else node.aiVal = dist;
						targets.push(node);
					}
				}
				targets.sortOn("aiVal", Array.NUMERIC);
				
				var target:Node = targets[0];
				if(target) {
					assets.length = 0;
					for(i = 0; i < l; i++) {
						node = nodes[i];
						if(node.team == team) {
							dx = node.x - target.x;
							dy = node.y - target.y;
							dist = Math.sqrt(dx*dx +dy*dy);
							node.aiVal = -node.size*node.energy + dist*0.01;
							assets.push(node);
						}
					}
					assets.sortOn("aiVal", Array.NUMERIC);
					
					var needed:int = int(target.size*50);
					for(i = assets.length-1; i >= 0 && needed > 0; i--) {
						var asset:Node = assets[i];
						var sent:int = game.sendShips(asset, target);
						needed -= sent;
					}
				}
				
				timer = delay + Math.random()*delay;
			}
		}
	}
}