package Game.Entity
{
	import Game.GameScene;

	public class EntityPool
	{
		public var active:Array;
		public var reserve:Array;
		public var game:GameScene;
		
		public function EntityPool()
		{
			active = [];
			reserve = [];
		}
		
		public function init(game:GameScene):void {
			this.game = game;
		}
		
		public function deInit():void {
			while(active.length > 0) {
				var entity:GameEntity = active.pop();
				entity.deInit();
				reserve.push(entity);
			}
			game = null;
		}
		
		public function addEntity(entity:GameEntity):void {
			active.push(entity);
		}
		
		public function getReserve():GameEntity {
			if(reserve.length > 0) return reserve.pop();
			else return null;
		}
		
		public function update(dt:Number):void {
			var l:int = active.length;
			for(var i:int = 0; i < l; i++) {
				var entity:GameEntity = active[i];
				if(!entity.active) {
					entity.deInit();
					reserve.push(entity);
					active[i] = active[l-1];
					active.pop();
					l--; i--;
				} else entity.update(dt);
			}
		}
	}
}