package Game.Entity
{
	import Game.GameScene;

	public class Node extends GameEntity
	{
		public var x:Number;
		public var y:Number;
		public var size:Number;
		public var baseSize:Number;
		public var energy:Number;
		public var team:int;
		public var captureTeam:int;
		
		public var selected:Boolean;
		public var aiVal:Number;
		
		public function Node()
		{
			super();
		}
		
		public function initNode(game:GameScene, x:Number, y:Number, size:Number):void {
			super.init(game);
			this.x = x;
			this.y = y;
			this.size = baseSize = size;
			team = 0;
			captureTeam = 0;
			energy = 0;
			selected = false;
		}
		
		public function setSize(size:Number):void {
			this.size = baseSize = size;
		}
		
		public override function update(dt:Number):void {
			if(team > 0 && energy < 1.0) {
				energy += dt*0.2;
				if(energy > 1.0) energy = 1.0;
			}
			if(size > baseSize) {
				size -= dt*0.5;
				if(size < baseSize) size = baseSize;
			}
		}
		
		public function hit(ship:Ship):void {
			if(team == 0) {
				if(captureTeam == ship.team) {
					energy += ship.energy;
					if(energy >= 1.0) {
						energy = 1.0;
						team = ship.team;
						GS.playPing01();
					}
				} else {
					if(energy == 0) {
						energy += ship.energy;
						captureTeam = ship.team;
					} else {
						energy -= ship.energy;
						if(energy <= 0) {
							energy = 0;
							captureTeam = ship.team;
						}
					}
				}
			} else {
				if(team == ship.team) {
					energy += ship.energy;
					if(energy >= 1.0) {
						energy = 1.0;
						//size += ship.energy*0.5;
						size += ship.energy*(baseSize/size)*0.5;
					}
				} else {
					energy -= ship.energy;
					if(energy <= 0) {
						energy = 0;
						team = ship.team;
						GS.playPing01();
					}
				}
			}
			GS.playHit();
		}
		
	}
}