package Game
{
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	
	public class PauseButton extends Sprite
	{
		public var label:Image;
		public var type:String;
		public var hitQuad:Quad;
		public var strike:Quad;
		public var on:Boolean;
		
		public function PauseButton(text:String)
		{
			label = new Image(Root.assets.getTexture("btn_"+text));
			label.touchable = false;
			addChild(label);
			this.type = text;
			
			strike = new Quad(70, 3, 0xda0000);
			strike.rotation = -0.1;
			strike.x = -10;
			strike.y = 9;
			strike.visible = false;
			addChild(strike);
			
			hitQuad = new Quad(85, 40, 0xff0000);
			hitQuad.alpha = 0;
			hitQuad.x = -18;
			hitQuad.y = -12;
			addChild(hitQuad);
			
			on = true;
			this.useHandCursor = true;
		}
		
		public function init():void {
			if(type == "sound") {
				if(Globals.soundVolume == 1) {
					on = true;
					label.color = 0xffffff;
					strike.visible = false;
				} else {
					on = false;
					label.color = 0xda0000;
					strike.visible = true;
				}
			}
			if(type == "music") {
				if(Globals.musicVolume == 1) {
					on = true;
					label.color = 0xffffff;
					strike.visible = false;
				} else {
					on = false;
					label.color = 0xda0000;
					strike.visible = true;
				}
			}
			addEventListener(TouchEvent.TOUCH, on_touch);
		}
		
		public function deInit():void {
			removeEventListener(TouchEvent.TOUCH, on_touch);
		}
		
		public function on_touch(e:TouchEvent):void {
			var touch:Touch = e.getTouch(this);
			if(!touch) {
				return;
			}
			
			switch(touch.phase) {
				case TouchPhase.HOVER:
					break;
				case TouchPhase.BEGAN:
					break;
				case TouchPhase.MOVED:
					break;
				case TouchPhase.ENDED:
					if(on) {
						on = false;
						label.color = 0xda0000;
						strike.visible = true;
						if(type == "sound") Globals.soundVolume = 0;
						if(type == "music") Globals.musicVolume = 0;
						GS.updateTransforms();
					} else {
						on = true;
						label.color = 0xffffff;
						strike.visible = false;
						if(type == "sound") Globals.soundVolume = 1;
						if(type == "music") Globals.musicVolume = 1;
						GS.updateTransforms();
					}
					break;
			}
		}
	}
}