package Game
{
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.text.BitmapFont;
	import starling.text.TextField;
	
	public class PauseMenu extends Sprite
	{
		public var bg:Quad;
		public var label:Image
		public var game:GameScene;
		
		public var continueButton:UIButton;
		public var quitButton:UIButton;
		
		public var sfxButton:PauseButton;
		public var bgmButton:PauseButton;
		
		public function PauseMenu(game:GameScene)
		{
			this.game = game;
			bg = new Quad(800, 600, 0x000000);
			bg.alpha = 0.7;
			addChild(bg);
			
			label = new Image(Root.assets.getTexture("title_paused"));
			label.x = Constants.STAGE_WIDTH*0.5 - label.width*0.5;
			label.y = 200;
			label.touchable = false;
			addChild(label);
			
			continueButton = new UIButton("btn_continue");
			continueButton.x = Constants.STAGE_WIDTH*0.5 - continueButton.width*0.5;
			continueButton.y = 300;
			addChild(continueButton);
			
			quitButton = new UIButton("btn_quit");
			quitButton.x = Constants.STAGE_WIDTH*0.5 - quitButton.width*0.5;
			quitButton.y = 360;
			addChild(quitButton);
			
			sfxButton = new PauseButton("sound");
			sfxButton.y = 20;
			sfxButton.x = 720;
			addChild(sfxButton);
			
			bgmButton = new PauseButton("music");
			bgmButton.y = 20;
			bgmButton.x = 720;
			//addChild(bgmButton);
		}
		
		public function show():void {
			//GS.stopMusic();
			visible = true;
			game.addChild(this);
			addEventListener(TouchEvent.TOUCH, on_touch);
			sfxButton.init();
			//bgmButton.init();
			continueButton.init();
			continueButton.addEventListener("clicked", on_continue);
			quitButton.init();
			quitButton.addEventListener("clicked", on_quit);
		}
		
		public function hide():void {
			//GS.playMusic();
			visible = false;
			removeEventListener(TouchEvent.TOUCH, on_touch);
			sfxButton.deInit();
			//bgmButton.deInit();
			continueButton.deInit();
			continueButton.removeEventListener("clicked", on_continue);
			quitButton.deInit();
			quitButton.removeEventListener("clicked", on_quit);
		}
		
		public function on_continue(e:Event):void {
			hide();
		}
		
		public function on_quit(e:Event):void {
			hide();
			game.quit();
		}
		
		public function on_touch(e:TouchEvent):void {
			var touch:Touch = e.getTouch(this);
			if(!touch) {
				return;
			}
			
			switch(touch.phase) {
				case TouchPhase.HOVER:
					break;
				case TouchPhase.BEGAN:
					break;
				case TouchPhase.MOVED:
					break;
				case TouchPhase.ENDED:
					//if(touch.globalY > 50 || touch.globalX < 600) hide();
					break;
			}
		}
	}
}