package Game
{
	import flash.geom.Point;
	
	import starling.display.Image;
	import starling.display.Quad;
	import starling.display.Sprite;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	
	public class UIButton extends Sprite
	{
		public var quad:Quad;
		public var hitQuad:Quad;
		public var image:Image;
		public var down:Boolean;
		public var hitPoint:Point;
		
		public function UIButton(str:String)
		{
			image = new Image(Root.assets.getTexture(str));
			image.color = 0xffffff;
			image.alpha = 0.5;
			addChild(image);
			
			quad = new Quad(image.width+20, image.height+20, 0xff0000);
			quad.x = -10;
			quad.y = -10;
			quad.alpha = 0;
			addChild(quad);
			
			hitPoint = new Point(0, 0);
			this.useHandCursor = true;
		}
		
		public function setImage(name:String, size:Number=1.0):void {
			image.texture = Root.assets.getTexture(name);
			image.readjustSize();
			image.width = image.texture.width;
			image.height = image.texture.height;
			image.scaleX = image.scaleY = size;
			image.alpha = 0.3;
			
			quad.width = image.width+20;
			quad.height = image.height+20;
			quad.x = -10;
			quad.y = -10;
			quad.alpha = 0;
		}
		
		public function init():void {
			image.alpha = 0.5;
			addEventListener(TouchEvent.TOUCH, on_touch);
		}
		
		public function deInit():void {
			removeEventListener(TouchEvent.TOUCH, on_touch);
		}
		
		public function on_touch(e:TouchEvent):void {
			var touch:Touch = e.getTouch(this);
			if(!touch) {
				image.alpha = 0.5;
				return;
			}
			
			switch(touch.phase) {
				case TouchPhase.HOVER:
					if(!down) image.alpha = 0.7;
					break;
				case TouchPhase.BEGAN:
					image.alpha = 1.0;
					down = true;
					break;
				case TouchPhase.MOVED:
					if(down && !hitTest(touch.getLocation(this, hitPoint))) {
						image.alpha = 0.5;
						down = false;
					}
					break;
				case TouchPhase.ENDED:
					if(down) {
						dispatchEventWith("clicked");
						image.alpha = 0.7;
						//GS.playClick();
					}
					down = false;
					break;
				
			}
		}
	}
}