package
{
	import Game.GameScene;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.system.Capabilities;
	import flash.ui.Keyboard;
	import flash.ui.Mouse;
	
	import starling.core.Starling;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.utils.AssetManager;
	
	[SWF(width="800", height="600", frameRate="60", backgroundColor="#000")]
	public class Main extends Sprite
	{	
		private var mStarling:Starling;
		
		public function Main()
		{
			if (stage) start();
			else addEventListener(flash.events.Event.ADDED_TO_STAGE, onAddedToStage);
		}
		
		private function start():void
		{
			Globals.main = this;
			Globals.load();
			Starling.multitouchEnabled = false; // for Multitouch Scene
			Starling.handleLostContext = true; // required on Windows, needs more memory
			
			mStarling = new Starling(Root, stage);
			mStarling.simulateMultitouch = false;
			mStarling.enableErrorChecking = Capabilities.isDebugger;
			mStarling.antiAliasing = 8;
			mStarling.start();
			//mStarling.showStats = true;
			
			// this event is dispatched when stage3D is set up
			mStarling.addEventListener(starling.events.Event.ROOT_CREATED, onRootCreated);
		}
		
		private function onAddedToStage(event:Object):void
		{
			removeEventListener(flash.events.Event.ADDED_TO_STAGE, onAddedToStage);
			start();
		}
		
		private function onRootCreated(event:starling.events.Event, root:Root):void
		{
			// set framerate to 30 in software mode
			if (mStarling.context.driverInfo.toLowerCase().indexOf("software") != -1)
				mStarling.nativeStage.frameRate = 30;
			
			// define which resources to load
			var assets:AssetManager = new AssetManager();
			assets.verbose = Capabilities.isDebugger;
			assets.enqueue(EmbeddedAssets);
			
			// game will first load resources, then start menu
			root.start(assets);
			//this.addEventListener(flash.events.Event.ACTIVATE, on_activate);
			//this.addEventListener(flash.events.Event.DEACTIVATE, on_deactivate);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, on_key_down);
			//Mouse.hide();
		}
		
		public function on_key_down(e:KeyboardEvent):void {
			var root:Root = mStarling.root as Root;
			var gameScene:GameScene = root.gameScene;
			switch(e.keyCode) {
				case Keyboard.P:
				case Keyboard.PAUSE:
				case Keyboard.ESCAPE:
					if(mStarling.root) {
						if(root.contains(gameScene) && gameScene.alpha == 1 && !gameScene.pauseMenu.visible) {
							gameScene.pauseMenu.show();
						} else if(root.contains(gameScene) && gameScene.pauseMenu.visible) {
							gameScene.pauseMenu.hide();
						}
					}
					break;
				case Keyboard.M:
					if(gameScene.pauseMenu.visible) return;
					if(Globals.soundVolume == 1 || Globals.musicVolume == 1) {
						Globals.soundVolume = 0;
						Globals.musicVolume = 0;
						GS.updateTransforms();
						GS.stopMusic();
					} else if(Globals.soundVolume == 0 && Globals.musicVolume == 0) {
						Globals.soundVolume = 1;
						Globals.musicVolume = 1;
						GS.updateTransforms();
						//GS.playMusic();
					}
					break;
			}
		}
		
		public function on_activate(e:*):void {
			/*if(mStarling.root) {
				var root:Root = mStarling.root as Root;
				var gameScene:GameScene = root.gameScene;
				if(root.contains(gameScene) && !gameScene.gameOver && gameScene.pauseMenu.visible) {
					gameScene.pauseMenu.visible = false;
				}
			}*/
			mStarling.start();
		}
		
		public function on_deactivate(e:*):void {
			if(mStarling.root) {
				var root:Root = mStarling.root as Root;
				var gameScene:GameScene = root.gameScene;
				if(root.contains(gameScene) && gameScene.alpha == 1 && !gameScene.pauseMenu.visible) {
					gameScene.pauseMenu.show();
				}
			}
			mStarling.stop();
		}
	}
}