package 
{
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.utils.getDefinitionByName;
	
	import starling.utils.Color;
	
	// To show a Preloader while the SWF is being transferred from the server, 
	// set this class as your 'default application' and add the following 
	// compiler argument: '-frame StartupFrame Demo_Web'
	
	[SWF(width="800", height="600", frameRate="60", backgroundColor="#000000")]
	public class Preloader extends MovieClip
	{
		private const STARTUP_CLASS:String = "Main";
		
		private var mFrameCount:int = 0;
		private var label:TextField;
		
		public function Preloader()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			stop();
		}
		
		private function onAddedToStage(event:Event):void 
		{
			stage.scaleMode = StageScaleMode.SHOW_ALL;
			stage.align = StageAlign.TOP_LEFT;
			
			label = new TextField();
			var tf:TextFormat = new TextFormat("Arial", 400, 0x333333, true, true);
			label.width = stage.stageWidth;
			label.height = stage.stageHeight;
			label.defaultTextFormat = tf;
			label.autoSize = TextFieldAutoSize.RIGHT;
			label.y = 240;
			label.text = "00";
			addChild(label);
			
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
		}
		
		private function onEnterFrame(event:Event):void 
		{
			var bytesLoaded:int = root.loaderInfo.bytesLoaded;
			var bytesTotal:int  = root.loaderInfo.bytesTotal;
			
			if (bytesLoaded >= bytesTotal)
			{
				dispose();
				run();
			}
			else
			{
				var p:int = (bytesLoaded / bytesTotal) * 100;
				label.text = p.toString();
			}
		}
		
		private function dispose():void 
		{
			removeEventListener(Event.ENTER_FRAME, onEnterFrame);
			
			if (label)
				removeChild(label);
			
			label = null;
		}
		
		private function run():void 
		{
			nextFrame();
			
			var startupClass:Class = getDefinitionByName(STARTUP_CLASS) as Class;
			if (startupClass == null)
				throw new Error("Invalid Startup class in Preloader: " + STARTUP_CLASS);
			
			var startupObject:DisplayObject = new startupClass() as DisplayObject;
			if (startupObject == null)
				throw new Error("Startup class needs to inherit from Sprite or MovieClip.");
			
			addChildAt(startupObject, 0);
		}
	}
}