package
{
    import Game.GameScene;
    
    import Menus.TitleMenu;
    
    import starling.core.Starling;
    import starling.display.Sprite;
    import starling.events.Event;
    import starling.utils.AssetManager;
    
    import utils.ProgressBar;
	
    public class Root extends Sprite
    {
        private static var sAssets:AssetManager;
        
        public var mActiveScene:Sprite;
		public var gameScene:GameScene;
		public var titleMenu:TitleMenu;
        
        public function Root()
        {
			
        }
        
        public function start(assets:AssetManager):void
        {
            sAssets = assets;
            
            var progressBar:ProgressBar = new ProgressBar(175, 20);
            progressBar.x = (800  - progressBar.width)  / 2;
            progressBar.y = (600 - progressBar.height) / 2;
            addChild(progressBar);
            
            assets.loadQueue(function onProgress(ratio:Number):void
            {
                progressBar.ratio = ratio;
                
                if (ratio == 1)
                    Starling.juggler.delayCall(function():void
                    {
                        progressBar.removeFromParent(true);
						GS.init();
						gameScene = new GameScene;
						titleMenu = new TitleMenu;
						initTitleMenu();
						//initGameScene();
                    }, 0.15);
            });
        }
		
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		// TITLE MENU
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		public function initTitleMenu():void {
			titleMenu.init();
			titleMenu.addEventListener("start", on_start);
			if(!contains(titleMenu)) addChild(titleMenu);
		}
		
		public function deInitTitleMenu():void {
			titleMenu.deInit();
			titleMenu.removeEventListener("start", on_start);
			//removeChild(titleMenu);
		}
		
		public function on_start(e:Event):void {
			deInitTitleMenu();
			initGameScene();
		}
		
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		// GAME SCENE
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		public function initGameScene():void {
			gameScene.init();
			gameScene.addEventListener("quit", on_quit);
			addChild(gameScene);
		}
		
		public function deInitGameScene():void {
			gameScene.deInit();
			gameScene.removeEventListener("quit", on_quit);
			removeChild(gameScene);
		}
		
		public function on_quit(e:Event):void {
			deInitGameScene();
			initTitleMenu();
			Globals.save();
		}
        
        public static function get assets():AssetManager { return sAssets; }
    }
}